package example.energy.coolemall;

import schedframe.Parameter;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.resources.computing.recs.ComputeBox1;
import schedframe.resources.computing.recs.NodeGroup;
import schedframe.scheduling.manager.tasks.JobRegistry;
import example.energy.BaseEnergyEstimationPlugin;

public class CB1EnergyEstimationPlugin extends BaseEnergyEstimationPlugin{

	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			ComputingResource resource) {
		double powerConsumption = 0;
		ComputeBox1 computeBox1 = (ComputeBox1)resource;
		for(NodeGroup ng:computeBox1.getNodesGroups()){
			try{
				powerConsumption = powerConsumption + ng.getPowerInterface().getRecentPowerUsage().getValue();
			} catch (Exception e){
				
			}
		}

		try {
			powerConsumption = powerConsumption + computeBox1.getPowerInterface().getPowerConsumption(computeBox1.getPowerInterface().getPowerState());
		} catch (NoSuchFieldException e) {
			Parameter param = computeBox1.getResourceCharacteristic().getParameters().get("maxPower");
			if(param != null)
				powerConsumption = powerConsumption + Double.valueOf(param.get(0).getContent());
		}

		
		return powerConsumption;
	}

}
